Index: /palm/trunk/SOURCE/modules.f90
===================================================================
--- /palm/trunk/SOURCE/modules.f90	(revision 2319)
+++ /palm/trunk/SOURCE/modules.f90	(revision 2320)
@@ -25,4 +25,9 @@
 ! -----------------
 ! $Id$
+! -ptnudge, qnudge, tnudge, td_lsa_lpt, td_lsa_q, td_sub_lpt, td_sub_q, ug_vert,
+!  vg_vert, unudge, vnudge, wsubs_vert, shf_surf, p_surf, pt_surf, q_surt,
+!  qsws_surf, tmp_tnudge, timenudge, time_surf, time_vert
+! 
+! 2300 2017-06-29 13:31:14Z raasch
 ! default value for host changed to '????', default value for loop_optimization
 ! changed to 'cache', default value for termination_time_needed set to 35.0
@@ -532,11 +537,7 @@
     REAL(wp), DIMENSION(:), ALLOCATABLE ::  ptdf_x                 !< damping factor for potential temperature in x-direction 
     REAL(wp), DIMENSION(:), ALLOCATABLE ::  ptdf_y                 !< damping factor for potential temperature in y-direction 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  p_surf                 !< time-dependent surface pressure (large scale forcing)
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  pt_surf                !< time-dependent surface temperature (large scale forcing)
     REAL(wp), DIMENSION(:), ALLOCATABLE ::  pt_init                !< initial profile of potential temperature 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  qsws_surf              !< time-dependent surface latent heat flux (large scale forcing)
     REAL(wp), DIMENSION(:), ALLOCATABLE ::  q_init                 !< initial profile of specific humidity 
                                                                    !< (or total water content with active cloud physics) 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  q_surf                 !< time-dependent surface specific humidity (large scale forcing)
     REAL(wp), DIMENSION(:), ALLOCATABLE ::  rdf                    !< rayleigh damping factor for velocity components 
     REAL(wp), DIMENSION(:), ALLOCATABLE ::  rdf_sc                 !< rayleigh damping factor for scalar quantities 
@@ -545,9 +546,4 @@
     REAL(wp), DIMENSION(:), ALLOCATABLE ::  s_init                 !< initial profile of passive scalar concentration
     REAL(wp), DIMENSION(:), ALLOCATABLE ::  sa_init                !< initial profile of salinity (ocean)
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  shf_surf               !< time-dependent surface sensible heat flux (large scale forcing)
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  timenudge              !< times at which vertical profiles are defined in NUDGING_DATA (nudging)
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  time_surf              !< times at which surface values/fluxes are defined in LSF_DATA (large scale forcing)
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  time_vert              !< times at which vertical profiles are defined in LSF_DATA (large scale forcing)
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  tmp_tnudge             !< current nudging time scale
     REAL(wp), DIMENSION(:), ALLOCATABLE ::  ug                     !< geostrophic wind component in x-direction
     REAL(wp), DIMENSION(:), ALLOCATABLE ::  u_init                 !< initial profile of horizontal velocity component u
@@ -593,21 +589,8 @@
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  precipitation_amount  !< precipitation amount due to gravitational settling (bulk microphysics)
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  precipitation_rate    !< precipitation rate (bulk microphysics)
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ptnudge               !< vertical profile of pot. temperature interpolated to vertical grid (nudging)
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  pt_slope_ref          !< potential temperature in rotated coordinate system 
                                                                     !< (in case of sloped surface) 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  qnudge                !< vertical profile of specific humidity interpolated to vertical grid (nudging) 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  tnudge                !< vertical profile of nudging time scale interpolated to vertical grid (nudging)  
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  td_lsa_lpt            !< temperature tendency due to large scale advection (large scale forcing)
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  td_lsa_q              !< specific humidity tendency due to large scale advection (large scale forcing)
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  td_sub_lpt            !< temperature tendency due to subsidence/ascent (large scale forcing)
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  td_sub_q              !< specific humidity tendency due to subsidence/ascent (large scale forcing)
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  total_2d_a            !< horizontal array to store the total domain data, used for atmosphere-ocean coupling (atmosphere data)
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  total_2d_o            !< horizontal array to store the total domain data, used for atmosphere-ocean coupling (ocean data)
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ug_vert               !< vertical profile of geostrophic wind component in x-direction interpolated to vertical grid (large scale forcing)
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  unudge                !< vertical profile of wind component in x-direction interpolated to vertical grid (nudging) 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  vnudge                !< vertical profile of wind component in y-direction interpolated to vertical grid (nudging) 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  vg_vert               !< vertical profile of geostrophic wind component in y-direction interpolated to vertical grid (large scale forcing)
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  wnudge                !< vertical profile of subsidence/ascent velocity interpolated to vertical grid (nudging) ???
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  wsubs_vert            !< vertical profile of wind component in z-direction interpolated to vertical grid (nudging) ???
     
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  d          !< divergence
@@ -1061,6 +1044,4 @@
     INTEGER(iwp) ::  mg_switch_to_pe0_level = -1       !< namelist parameter
     INTEGER(iwp) ::  mid                               !< masked output running index
-    INTEGER(iwp) ::  nlsf = 1000                       !< maximum number of profiles in LSF_DATA (large scale forcing)
-    INTEGER(iwp) ::  ntnudge = 1000                    !< maximum number of profiles in NUDGING_DATA (nudging)
     INTEGER(iwp) ::  ngsrb = 2                         !< namelist parameter
     INTEGER(iwp) ::  nr_timesteps_this_run = 0         !< number of timesteps (cpu time measurements)
Index: /palm/trunk/SOURCE/palm.f90
===================================================================
--- /palm/trunk/SOURCE/palm.f90	(revision 2319)
+++ /palm/trunk/SOURCE/palm.f90	(revision 2320)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Modularize large-scale forcing and nudging
+! 
+! 2298 2017-06-29 09:28:18Z raasch
 ! type of write_binary changed from CHARACTER to LOGICAL,
 ! user interface required revision updated, MPI2 related part removed
@@ -207,10 +210,4 @@
         ONLY:  lsm_last_actions
 
-    USE ls_forcing_mod,                                                        &
-        ONLY:  init_ls_forcing
-
-    USE nudge_mod,                                                             &
-        ONLY:  init_nudge
-
     USE particle_attributes,                                                   &
         ONLY:  particle_advection
@@ -330,16 +327,4 @@
 !-- Generate grid parameters
     CALL init_grid
-
-!
-!-- Initialize nudging if required
-    IF ( nudging )  THEN
-       CALL init_nudge
-    ENDIF
-
-!
-!-- Initialize reading of large scale forcing from external file - if required
-    IF ( large_scale_forcing )  THEN
-       CALL init_ls_forcing
-    ENDIF
 
 !
Index: /palm/trunk/SOURCE/prognostic_equations.f90
===================================================================
--- /palm/trunk/SOURCE/prognostic_equations.f90	(revision 2319)
+++ /palm/trunk/SOURCE/prognostic_equations.f90	(revision 2320)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Modularize large-scale forcing and nudging
+! 
+! 2292 2017-06-20 09:51:42Z schwenkel
 ! Implementation of new microphysic scheme: cloud_scheme = 'morrison' 
 ! includes two more prognostic equations for cloud drop concentration (nc)  
@@ -325,12 +328,9 @@
     USE kinds
 
-    USE ls_forcing_mod,                                                        &
-        ONLY:  ls_advec
+    USE lsf_nudging_mod,                                                       &
+        ONLY:  ls_advec, nudge
 
     USE microphysics_mod,                                                      &
         ONLY:  microphysics_control
-
-    USE nudge_mod,                                                             &
-        ONLY:  nudge
 
     USE plant_canopy_model_mod,                                                &
Index: /palm/trunk/SOURCE/read_var_list.f90
===================================================================
--- /palm/trunk/SOURCE/read_var_list.f90	(revision 2319)
+++ /palm/trunk/SOURCE/read_var_list.f90	(revision 2320)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Formatting adjustment
+! 
+! 2265 2017-06-08 16:58:28Z schwenkel
 ! Unused variables removed.
 ! 
@@ -504,5 +507,5 @@
           CASE ( 'large_scale_forcing' )
              READ ( 13 )  large_scale_forcing
-           CASE ( 'large_scale_subsidence' )
+          CASE ( 'large_scale_subsidence' )
              READ ( 13 )  large_scale_subsidence
           CASE ( 'limiter_sedimentation' )
Index: /palm/trunk/SOURCE/time_integration.f90
===================================================================
--- /palm/trunk/SOURCE/time_integration.f90	(revision 2319)
+++ /palm/trunk/SOURCE/time_integration.f90	(revision 2320)
@@ -343,12 +343,9 @@
                skip_time_do_lsm
 
-    USE ls_forcing_mod,                                                        &
-        ONLY:  ls_forcing_surf, ls_forcing_vert
+    USE lsf_nudging_mod,                                                       &
+        ONLY:  calc_tnudge, ls_forcing_surf, ls_forcing_vert, nudge_ref
 
     USE microphysics_mod,                                                      &
         ONLY: collision_turbulence
-
-    USE nudge_mod,                                                             &
-        ONLY:  calc_tnudge, nudge_ref
 
     USE particle_attributes,                                                   &
@@ -764,5 +761,5 @@
                  intermediate_timestep_count == intermediate_timestep_count_max )&
              THEN
-                CALL ls_forcing_surf ( simulated_time )
+                CALL ls_forcing_surf( simulated_time )
              ENDIF
 
